var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import {} from "@xieyuheng/commander.js";
import fs from "fs";
import Path from "path";
import { run } from "../lang/run/index.js";
export const runCommand = {
    name: "run",
    description: "Run a file",
    help(commander) {
        return [
            `The ${this.name} command run a file.`,
            ``,
            `  ${commander.name} ${this.name} <file>`,
            ``,
        ].join("\n");
    },
    run(commander) {
        return __awaiter(this, void 0, void 0, function* () {
            const url = createURL(String(commander.args[0]));
            try {
                yield run(url);
            }
            catch (error) {
                if (error instanceof Error) {
                    console.error(error.message);
                    process.exit(1);
                }
                process.exit(1);
            }
        });
    },
};
function createURL(path) {
    try {
        return new URL(path);
    }
    catch (_) {
        if (fs.existsSync(path) && fs.lstatSync(path).isFile()) {
            const fullPath = Path.resolve(path);
            return new URL(`file:${fullPath}`);
        }
        throw new Error(`I can not create URL from path: ${path}`);
    }
}
//# sourceMappingURL=runCommand.js.map