import { expFreeNames } from "../exp/expFreeNames.js";
import { modDefine } from "../mod/index.js";
import { importOne } from "./importOne.js";
export function define(mod, stmt) {
    switch (stmt.kind) {
        case "Define": {
            modDefine(mod, stmt.name, {
                mod,
                name: stmt.name,
                exp: stmt.exp,
                freeNames: expFreeNames(new Set(), stmt.exp),
            });
            return null;
        }
        case "Import": {
            for (const entry of stmt.entries) {
                importOne(mod, stmt.path, entry);
            }
            return null;
        }
        default: {
            return null;
        }
    }
}
//# sourceMappingURL=define.js.map