import { type Exp } from "../exp/Exp.ts";
export type Stmt = AssertEqual | AssertNotEqual | Compute | Define | Import;
export type AssertEqual = {
    kind: "AssertEqual";
    exps: Array<Exp>;
};
export type AssertNotEqual = {
    kind: "AssertNotEqual";
    exps: Array<Exp>;
};
export type Compute = {
    kind: "Compute";
    exp: Exp;
};
export type Define = {
    kind: "Define";
    name: string;
    exp: Exp;
};
export type Import = {
    kind: "Import";
    path: string;
    entries: Array<ImportEntry>;
};
export type ImportEntry = {
    name: string;
    rename?: string;
};
export declare function AssertEqual(exps: Array<Exp>): AssertEqual;
export declare function AssertNotEqual(exps: Array<Exp>): AssertNotEqual;
export declare function Compute(exp: Exp): Compute;
export declare function Define(name: string, exp: Exp): Define;
export declare function Import(path: string, entries: Array<ImportEntry>): Import;
//# sourceMappingURL=Stmt.d.ts.map