import type { Exp } from "../exp/index.ts";
export type Binding = {
    name: string;
    exp: Exp;
};
export type Substitution = Map<string, Binding>;
export declare function substitutionIsEmpty(substitution: Substitution): boolean;
export declare function substitutionFromBindings(bindings: Array<Binding>): Substitution;
export declare function substitutionBindings(substitution: Substitution): Array<Binding>;
export declare function substitutionInitial(name: string, exp: Exp): Substitution;
export declare function substitutionExtend(substitution: Substitution, name: string, exp: Exp): Substitution;
export declare function substitutionMerge(left: Substitution, right: Substitution): Substitution;
export declare function substitutionMapExp(substitution: Substitution, f: (exp: Exp) => Exp): Substitution;
export declare function substitutionTakeNames(substitution: Substitution, names: Set<string>): Substitution;
//# sourceMappingURL=Substitution.d.ts.map