export function substitutionIsEmpty(substitution) {
    return substitution.size === 0;
}
export function substitutionFromBindings(bindings) {
    return new Map([
        ...bindings.map((binding) => [binding.name, binding]),
    ]);
}
export function substitutionBindings(substitution) {
    return Array.from(substitution.values());
}
export function substitutionInitial(name, exp) {
    return new Map([[name, { name, exp }]]);
}
export function substitutionExtend(substitution, name, exp) {
    return new Map([...substitution, [name, { name, exp }]]);
}
export function substitutionMerge(left, right) {
    return new Map([...left, ...right]);
}
export function substitutionMapExp(substitution, f) {
    return new Map([
        ...Array.from(substitution.values()).map(({ name, exp }) => [name, { name, exp: f(exp) }]),
    ]);
}
export function substitutionTakeNames(substitution, names) {
    const newSubstitution = new Map();
    for (const [name, exp] of substitution) {
        if (names.has(name)) {
            newSubstitution.set(name, exp);
        }
    }
    return newSubstitution;
}
//# sourceMappingURL=Substitution.js.map