import { type Env } from "../env/index.ts";
import { type Exp } from "../exp/index.ts";
import { type Mod } from "../mod/index.ts";
import { type Neutral } from "../neutral/index.ts";
export type Value = NotYet | Fn | FnRec | Lazy;
export type NotYet = {
    kind: "NotYet";
    neutral: Neutral;
};
export type Lazy = {
    kind: "Lazy";
    mod: Mod;
    env: Env;
    exp: Exp;
    cache?: Value;
};
export type Fn = {
    kind: "Fn";
    mod: Mod;
    env: Env;
    name: string;
    ret: Exp;
};
export type FnRec = {
    kind: "FnRec";
    mod: Mod;
    env: Env;
    recName: string;
    name: string;
    ret: Exp;
};
export declare function NotYet(neutral: Neutral): NotYet;
export declare function Lazy(mod: Mod, env: Env, exp: Exp, cache?: Value): Lazy;
export declare function Fn(mod: Mod, env: Env, name: string, ret: Exp): Fn;
export declare function FnRec(mod: Mod, env: Env, recName: string, name: string, ret: Exp): FnRec;
//# sourceMappingURL=Value.d.ts.map